<?php
/*
Plugin Name: Theme Cleaner
Description: Removes theme elements like website field in comment form, short url, xml-rpc link
Author: Abdussamad
Version: 0.1.2
Author URI: http://abdussamad.com
License: GPLv2
Plugin URI: http://abdussamad.com/?p=784
*/

class abd_theme_cleaner {

    const VERSION = '0.1.2';
    
    function __construct() {
        $this->save_version();
        
        add_filter( 'comment_form_defaults', array( $this, 'clean_comment_form' ) );
        
        $this->clean_head();
        
        add_action( 'wp_head', array( $this, 'add_default_feed_link' ) );
    }
    
    function save_version() {
        update_option( 'abd_theme_cleaner_version', self::VERSION );
    }
 
    function clean_comment_form( $defaults ) {
        //remove html code hints below comment message form
        $defaults[ 'comment_notes_after' ] = '';

        //remove "website" field
        $defaults[ 'fields' ][ 'url' ] = '';

        return $defaults;
    }
    
    private function clean_head() {
        remove_action( 'wp_head', 'feed_links_extra', 3 );
        remove_action( 'wp_head', 'feed_links', 2 );
        
        remove_action( 'wp_head', 'rsd_link');
        
        remove_action( 'wp_head', 'wlwmanifest_link');
        
        remove_action( 'wp_head', 'adjacent_posts_rel_link_wp_head', 10, 0);
        
        remove_action( 'wp_head', 'wp_generator');
        remove_action( 'wp_head', 'wp_shortlink_wp_head');
    }
    
    public function add_default_feed_link() {
       echo "<link rel='alternate' type='application/rss+xml' title='" . get_bloginfo('name') . " &raquo; Feed' href='" . get_feed_link() . "' />";
    }
}

new abd_theme_cleaner();
